ompi/mca/ptl/mx/ptl_mx.h File Reference.TH "ompi/mca/ptl/mx/ptl_mx.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/mx/ptl_mx.h \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include <myriexpress.h>\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'mca/ptl/ptl.h'\fP
.br
\fC#include 'class/ompi_bitmap.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'class/orte_proc_table.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_MX_STATISTICS\fP   0"
.br
.ti -1c
.RI "#define \fBHAVE_MX_ICOMPLETED\fP   0"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_ptl_mx_component_t\fP \fBmca_ptl_mx_component_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_mx_module_t\fP \fBmca_ptl_mx_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_ptl_mx_component_open\fP (void)"
.br
.RI "\fIRegister MX module parameters with the MCA framework. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_component_close\fP (void)"
.br
.RI "\fIAny final cleanup before being unloaded. \fP"
.ti -1c
.RI "\fBmca_ptl_base_module_t\fP ** \fBmca_ptl_mx_component_init\fP (int *num_ptls, bool allow_multi_user_threads, bool have_hidden_threads)"
.br
.RI "\fIMCA->PTL Intializes the PTL component and creates specific PTL module(s). \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_component_control\fP (int param, void *value, size_t size)"
.br
.RI "\fIMCA->PTL Called to dynamically change a component parameter. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_component_progress\fP (mca_ptl_tstamp_t tstamp)"
.br
.RI "\fIMCA->PTL Called to progress outstanding requests for non-threaded polling environments. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_module_init\fP (void)"
.br
.RI "\fICreate/initialize the MX PTL modules. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_finalize\fP (struct \fBmca_ptl_base_module_t\fP *ptl)"
.br
.RI "\fICleanup any resources held by the PTL. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_add_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers, ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_del_procs\fP (struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peers)"
.br
.RI "\fIPML->PTL notification of change to the process list. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_request_init\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Initialize a send request for use by the PTL. \fP"
.ti -1c
.RI "void \fBmca_ptl_mx_request_fini\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.br
.RI "\fIPML->PTL Cleanup any resources that may have been associated with the request by the PTL. \fP"
.ti -1c
.RI "void \fBmca_ptl_mx_matched\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *frag)"
.br
.RI "\fIPML->PTL Notification from the PML to the PTL that a receive has been posted and matched against the indicated fragment. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_send\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a send to the peer. \fP"
.ti -1c
.RI "int \fBmca_ptl_mx_send_continue\fP (struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_peer, struct \fBmca_ptl_base_send_request_t\fP *, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Continue sending fragments of a large message. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "struct \fBmca_ptl_mx_component_t\fP \fBmca_ptl_mx_component\fP"
.br
.ti -1c
.RI "\fBmca_ptl_mx_module_t\fP \fBmca_ptl_mx_module\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_ptl_mx_add_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** procs, struct \fBmca_ptl_base_peer_t\fP ** peers, ompi_bitmap_t * reachable)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeers\fP (OUT) Set of (optional) peer addressing info. 
.br
\fIpeers\fP (IN/OUT) Set of processes that are reachable via this PTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "int mca_ptl_mx_component_control (int param, void * value, size_t size)"
.PP
MCA->PTL Called to dynamically change a component parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIflag\fP (IN) Parameter to change. 
.br
\fIvalue\fP (IN) Optional parameter value.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure.
.RE
.PP
The only supported parameter is currently MCA_PTL_ENABLE, which can be used by the PML to enable/disable forwarding by the PTL. 
.SS "\fBmca_ptl_base_module_t\fP** mca_ptl_mx_component_init (int * num_ptls, bool allow_multi_user_threads, bool have_hidden_threads)"
.PP
MCA->PTL Intializes the PTL component and creates specific PTL module(s). 
.PP
\fBParameters:\fP
.RS 4
\fInum_ptls\fP (OUT) Returns the number of ptl instances created, or 0 if the transport is not available.
.br
\fIallow_multi_user_threads\fP (OUT) Indicated wether this component can run at MPI_THREAD_MULTIPLE or not.
.br
\fIhave_hidden_threads\fP (OUT) Whether this component uses hidden threads (e.g., progress threads) or not.
.RE
.PP
\fBReturns:\fP
.RS 4
Array of pointers to PTL modules, or NULL if the transport is not available.
.RE
.PP
During component initialization, the PTL component should discover the physical devices that are available for the given transport, and create a PTL instance to represent each device. Any addressing information required by peers to reach the device should be published during this function via the \fBmca_pml_base_modex_send()\fP interface. 
.SS "int mca_ptl_mx_component_progress (mca_ptl_tstamp_t tstamp)"
.PP
MCA->PTL Called to progress outstanding requests for non-threaded polling environments. 
.PP
\fBParameters:\fP
.RS 4
\fItstamp\fP Current time. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure. 
.RE
.PP

.SS "int mca_ptl_mx_del_procs (struct \fBmca_ptl_base_module_t\fP * ptl, size_t nprocs, struct ompi_proc_t ** proc, struct \fBmca_ptl_base_peer_t\fP ** ptl_peer)"
.PP
PML->PTL notification of change to the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fInproc\fP (IN) Number of processes. 
.br
\fIprocs\fP (IN) Set of processes. 
.br
\fIpeers\fP (IN) Set of peer data structures. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful 
.RE
.PP

.SS "int mca_ptl_mx_finalize (struct \fBmca_ptl_base_module_t\fP * ptl)"
.PP
Cleanup any resources held by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP PTL instance. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "void mca_ptl_mx_matched (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_recv_frag_t\fP * frag)"
.PP
PML->PTL Notification from the PML to the PTL that a receive has been posted and matched against the indicated fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP Matched fragment
.RE
.PP
The ptl_matched() function is called by the PML when a fragment is matched to a posted receive. This may occur during a call to ptl_match() if the receive is matched, or at a later point in time when a matching receive is posted.
.PP
When this routine is called, the PTL is responsible for generating an acknowledgment to the peer if the MCA_PTL_FLAGS_ACK bit is set in the original fragment header. Additionally, the PTL is responsible for transferring any data associated with the fragment into the users buffer utilizing the datatype engine, and notifying the PML that the fragment has completed via the ptl_recv_progress() function. 
.SS "int mca_ptl_mx_module_init (void)"
.PP
Create/initialize the MX PTL modules. 
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure. 
.RE
.PP

.SS "void mca_ptl_mx_request_fini (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Cleanup any resources that may have been associated with the request by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request.
.RE
.PP
The ptl_request_fini function is called when the PML removes a request from the PTLs cache (due to resource constraints). This routine provides the PTL the chance to cleanup/release any resources cached on the send descriptor by the PTL. 
.SS "int mca_ptl_mx_request_init (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_send_request_t\fP *)"
.PP
PML->PTL Initialize a send request for use by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request.
.RE
.PP
To reduce latency (number of required allocations), the PML allocates up to ptl_cache_bytes of additional space contigous w/ the base send request. This space may be used by the PTL for additional control information (e.g. first fragment descriptor).
.PP
The ptl_request_init() function is called by the PML when requests are allocated to the PTLs cache. These requests will be cached by the PML on completion and re-used by the same PTL w/out additional calls to ptl_request_init().
.PP
If the cache size is exceeded, the PML may pass requests to ptl_send/ptl_put that have been taken from the global pool and have not been initialized by the PTL. These requests will have the req_cached attribute set to false. 
.SS "int mca_ptl_mx_send (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_peer_t\fP * ptl_peer, struct \fBmca_ptl_base_send_request_t\fP * sendreq, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a send to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIrequest\fP (IN) Send request 
.br
\fIoffset\fP Current offset into packed/contiguous buffer. 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver, 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments
.RE
.PP
The PML implements a rendevouz protocol, with up to the PTL threshold (ptl_first_frag_size) bytes of the message sent in eager send mode. The ptl_send() function is called by the PML to initiate the send of the first message fragment.
.PP
The PTL is responsible for updating the current data offset (req_offset) in the request to reflect the actual number of bytes fragmented. This may be less than the requested size, due to resource constraints or datatype alighnment/offset. If an acknowledgment is required, the MCA_PTL_FLAGS_ACK bit will be set in the flags parameter. In this case, the PTL should not call ptl_send_progress() function to indicate completion of the fragment until the ack is received. For all other fragments ptl_send_progress() may be called based on local completion semantics. 
.SS "int mca_ptl_mx_send_continue (struct \fBmca_ptl_base_module_t\fP * ptl, struct \fBmca_ptl_base_peer_t\fP * ptl_peer, struct \fBmca_ptl_base_send_request_t\fP * sendreq, size_t offset, size_t size, int flags)"
.PP
PML->PTL Continue sending fragments of a large message. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIrequest\fP (IN) Send request 
.br
\fIoffset\fP Current offset into packed/contiguous buffer. 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver, 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments
.RE
.PP
Continue sending fragments of a large message to the peer. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
